import time
import board
import busio
import adafruit_ads1x15.ads1115 as ADS
from adafruit_ads1x15.analog_in import AnalogIn

# Creacion del bus I2C
i2c = busio.I2C(board.SCL, board.SDA)

# Creacion de un objeto ads de libreria usando el bus I2C
ads = ADS.ADS1115(i2c)

# Creacion de entradas simples en canales 0 y 1
A0 = AnalogIn(ads, ADS.P0)
A1 = AnalogIn(ads, ADS.P1)
cell = AnalogIn(ads, ADS.P2)

# Formato de la tabla de pruebas
print("| A0_val |   A0_V | A1_val |   A1_V | cell_N | cell_V |".format(*range(6)))
print("-"*37)

# Mostrar los valores
while True:
    print("| {0:>6} | {1:>6} | {2:>6} | {3:>6} | {4:>6} | {5:>6} |".format(A0.value, round(A0.voltage,4), A1.value, round(A1.voltage,4), cell.value, round(cell.voltage,4)))
    time.sleep(0.5)
