import time
import board
import busio
import numpy as np
import adafruit_ads1x15.ads1115 as ADS
from adafruit_ads1x15.analog_in import AnalogIn

# Creacion del bus I2C
i2c = busio.I2C(board.SCL, board.SDA)

# Creacion de un objeto ads de libreria usando el bus I2C
ads = ADS.ADS1115(i2c)

# Creacion de entradas simples en canales 0 y 1
A0 = AnalogIn(ads, ADS.P0)
A1 = AnalogIn(ads, ADS.P1)
A2 = AnalogIn(ads, ADS.P2)

# Declaro arrays para media móvil
A0_Xarr = np.array([0, 0, 0, 0, 0])
A0_Varr = np.array([0, 0, 0, 0, 0])
A1_Xarr = np.array([0, 0, 0, 0, 0])
A1_Varr = np.array([0, 0, 0, 0, 0])
A2_Xarr = np.array([0, 0, 0, 0, 0])
A2_Varr = np.array([0, 0, 0, 0, 0])

# Formato de la tabla de pruebas
print("| A0_val |   A0_V | A1_val |   A1_V | cell_N | cell_V |".format(*range(6)))
print("-"*37)

# Bucle del programa
while True:
    # Bucle media movil
    A0_Xarr = np.delete(A0_Xarr, 0)
    A0_Xarr = np.append(A0_Xarr, A0.value)
    A0_Varr = np.delete(A0_Varr, 0)
    A0_Varr = np.append(A0_Varr, round(A0.voltage,4))
    A1_Xarr = np.delete(A1_Xarr, 0)
    A1_Xarr = np.append(A1_Xarr, A1.value)
    A1_Varr = np.delete(A1_Varr, 0)
    A1_Varr = np.append(A1_Varr, round(A1.voltage,4))
    A2_Xarr = np.delete(A2_Xarr, 0)
    A2_Xarr = np.append(A2_Xarr, A2.value)
    A2_Varr = np.delete(A2_Varr, 0)
    A2_Varr = np.append(A2_Varr, round(A2.voltage,4))
        
    A0_Xavg = np.sum(A0_Xarr)/5
    A0_Vavg = round((np.sum(A0_Varr)/5),4)
    A1_Xavg = np.sum(A1_Xarr)/5
    A1_Vavg = round((np.sum(A1_Varr)/5),4)
    A2_Xavg = np.sum(A2_Xarr)/5
    A2_Vavg = round((np.sum(A2_Varr)/5),4)
    
    # Mostrar valores
    print("| {0:>6} | {1:>6} | {2:>6} | {3:>6} | {4:>6} | {5:>6} |".format(A0_Xavg, A0_Vavg, A1_Xavg, A1_Vavg, A2_Xavg, A2_Vavg))
    time.sleep(0.5)